/*
 * Fasterfox is copyright 2005 by Tony Gentilcore. 
 *
 * If you wish to modify, distribute, or reproduce all
 * or part if this extension, please write me first.
 * 
 * No portion of this extension or the code contained 
 * herein this archive may be reproduced without the 
 * express written consent of the author.
 * 
 */

// create arrays of the form elements for use in the code below
var _elementIDs =	["ff_presets", "ff_enhancedPrefetching","ff_pipelining","ff_pipeliningFirstRequest","ff_proxyPipelining",
					"ff_pageLoadTimer", "ff_cacheMemoryCapacity","ff_cacheDiskCapacity","ff_maxConnections", 
					"ff_maxConnectionsPerServer", "ff_maxPersistentConnectionsPerServer","ff_maxPersistentConnectionsPerProxy","ff_maxPipeliningRequests", 
					"ff_initialPaintDelay", "ff_disablePluginPopups", "ff_dnsCacheExpiration", "ff_dnsCacheEntries", 
					"ff_uiSubmenuDelay"];

// Presets: [Default, Good Net Citizen, Optimized, Turbo Charged]
// ff_presets[n] corresponds to _elementIDs[n+1]
var ff_presets =	new Array([false, false, true, true], [false, false, true, true], [false, false, true, true], [false, false, true, true],
					[true, true, true, true], [-1, 65536, 65536, 65536], [50000, 76800, 76800, 76800], [24, 24, 40, 48], 
					[8, 8, 16, 24], [2, 2, 6, 8], [4, 4, 12, 16], [4, 4, 6, 8], 
					[250, 0, 0, 0], [0, 2, 2, 2], [60, 3600, 3600, 3600], [20, 512, 512, 512], 
					[300, 50, 50, 50]);
				
/*
 * load all preferences into a PrefWindowIV dialog
 * this makes use of the old PrefWindowIV callbacks and functions
 */
function Startup() {
	// open the most recently viewed tab if custom is selected
	document.getElementById("ff_tabs").selectedIndex = parent.hPrefWindow.getPref("int", "extensions.fasterfox.lastTab", 0);
	
	// show or hide the advanced tabs for Prefs IV
	if(parent.hPrefWindow.getPref("int", "extensions.fasterfox.preset", 3) == 4) {
		FF_displayTabs(true);
	} else {
		FF_displayTabs(false);
	}
	
	// check or uncheck the popups checkbox based on the preference setting
	if(parent.hPrefWindow.getPref("int", "privacy.popups.disable_from_plugins", 2) == 2) {
		document.getElementById('ff_disablePluginPopupsCheckbox').checked=true;
	} else {
		document.getElementById('ff_disablePluginPopupsCheckbox').checked=false;
	}

	// register the PrefWindowIV OK-button callback
  	parent.hPrefWindow.registerOKCallbackFunc(FF_onOK);

}

/*
 * save all preferences from an old PrefWindowIV dialog
 */
function FF_onOK() {
	
	// save the most recently viewed tab
	try {
		parent.hPrefWindow.setPref("int", "extensions.fasterfox.lastTab", document.getElementById('ff_tabs').selectedIndex);
	} catch(e){}
	
	return true;	
}

function FF_setPreset(presetNumber) {
    var i, pref, element;
    // Set the form elements to the proper preset
	for (i = 0; i < ff_presets.length; i++) {
		element = document.getElementById(_elementIDs[i+1]);
  		pref = document.getElementById(element.getAttribute("preference"));
  		if(pref) {
	  		// Pref V
	  		pref.value = ff_presets[i][presetNumber];
  		} else {
	  		// Pref IV
	  		//alert(element.getAttribute("prefstring") + ' = ' + ff_presets[i][presetNumber]);	  		
	  		parent.hPrefWindow.setPref(element.getAttribute("preftype"), element.getAttribute("prefstring"), ff_presets[i][presetNumber]);
	  		if (element.getAttribute("preftype") == "bool")
	  			element.checked = ff_presets[i][presetNumber];
	  		else
	  			element.value = ff_presets[i][presetNumber];
  		}
  	}
}

/*
 * Accepts a boolean value which determines whether
 * all tabs should be shown or hidden
 *
 * true = display all tabs
 * false = hide all tabs
 */
function FF_displayTabs(show) {
    
	// hide or show the tabs
	document.getElementById("ff_tabs").setAttribute("hidden", !show);
	
}
